<?php

class PieceSquadro {
    const BLANC = 0;
    const NOIR = 1;
    const VIDE = 2;
    const NEUTRE = 3;
    const NORD = 4;
    const EST = 5;
    const SUD = 6;
    const OUEST = 7;

    private $couleur;
    private $direction;

    private function __construct($couleur, $direction) {
        $this->couleur = $couleur;
        $this->direction = $direction;
    }

    public static function initVide() {
        return new self(self::VIDE, self::NORD);
    }

    public static function initNoirNord() {
        return new self(self::NOIR, self::NORD);
    }

    public static function initNoirSud() {
        return new self(self::NOIR, self::SUD);
    }

    public static function initBlancEst() {
        return new self(self::BLANC, self::EST);
    }

    public static function initBlancOuest() {
        return new self(self::BLANC, self::OUEST);
    }

    public function getCouleur() {
        return $this->couleur;
    }

    public function getDirection() {
        return $this->direction;
    }

    public function inverseDirection() {
        $this->direction = ($this->direction === self::NORD) ? self::SUD : self::NORD;
    }

    public function toJson() {
        return json_encode(['couleur' => $this->couleur, 'direction' => $this->direction]);
    }

    public static function fromJson($json) {
        $data = json_decode($json, true);
        return new self($data['couleur'], $data['direction']);
    }
}
?>